this.name					= "milGrid_script.js";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "Enhanced shield recharging unit";
this.version				= "1.0";

this.activated = function()
	{
	if(player.ship.equipmentStatus("EQ_NAVAL_GRID") !== "EQUIPMENT_OK")
		{ return; }
	
	if(player.ship.energy < 64)
		{
		player.consoleMessage("Grid energy low - routing to reserve banks", 4);
		return;
		}
	
	if(	player.ship.forwardShield === player.ship.maxForwardShield && player.ship.aftShield === player.ship.maxAftShield)
		{
		player.consoleMessage("Grid energy routed to reserves - shields full",4);
		this.shipExitedWitchspace();
		return;
		}
		
	if(!this.shieldCheckTimer || !this.shieldCheckTimer.isRunning)
		{
		this.shipExitedWitchspace();
		player.consoleMessage("Grid energy routed to shields",4);
		}
	else
		{ 
		this.shipDied(); 
		player.consoleMessage("Grid energy routed to reserves",4);
		}
	}	

this.shipLaunchedFromStation = function()
	{
	this.shipExitedWitchspace();
	delete this.shipLaunchedFromStation;
	}

this.shipExitedWitchspace = function()
	{
	if(player.ship.equipmentStatus("EQ_NAVAL_GRID") === "EQUIPMENT_OK")
		{	
		if(this.shieldCheckTimer)
			{ this.shieldCheckTimer.start() }
		else
			{ this.shieldCheckTimer = new Timer(this, this.shieldCheck, 0, 0.25) }
		}	
	}

this.shieldCheck = function()
	{
	this.strength = 1; // adjust this value if you want more energy transferred from the banks to the shields by the grid
	
	if(player.ship.equipmentStatus("EQ_NAVAL_SHIELD_BOOSTER") !== "EQUIPMENT_OK" || player.ship.equipmentStatus("EQ_NAVAL_ENERGY_UNIT") !== "EQUIPMENT_OK")
		{ // as this.equipmentDamaged doesn't fire in this kind of script?
		player.consoleMessage("Naval Grid damaged and offline", 4);
		player.ship.setEquipmentStatus("EQ_NAVAL_GRID", "EQUIPMENT_DAMAGED");
		if(this.shieldCheckTimer) { this.shieldCheckTimer.stop(); }
		return;
		}
	
	if(player.ship.docked || player.ship.equipmentStatus("EQ_NAVAL_GRID") !== "EQUIPMENT_OK")
		{ 
		this.shieldCheckTimer.stop(); 
		return;
		}
	else
		{
		if(player.ship.energy < 64) // if there's too little energy to recharge the shields
			{ return; }
					
		if ((player.ship.forwardShield < player.ship.maxForwardShield) || (player.ship.aftShield < player.ship.maxAftShield))
			{//  if at least one of the shields is below maximum
			this.sequence = 0; // reset the flag to say which is more depleted

			if((player.ship.maxForwardShield - player.ship.forwardShield) < (player.ship.maxAftShield - player.ship.aftShield))
				{ // if the aft shield is more depleted
				player.ship.aftShield += this.strength;
				player.ship.energy -= this.strength;
				this.sequence = 2;
			
				}
			else
				{ // if the forward shield is more depleted
				player.ship.forwardShield += this.strength;
				player.ship.energy -= this.strength;
				this.sequence = 1;
				}
		
			if(this.sequence === 1 && player.ship.energy > 127 && (player.ship.aftShield < player.ship.maxAftShield))
				{ // if we just strengthened the forward shield, but the aft shield also needs some juice and we have the energy for it
				player.ship.aftShield += this.strength;
				player.ship.energy -= this.strength;			
				return;
				}

			if(this.sequence === 2 && player.ship.energy > 127 && (player.ship.forwardShield < player.ship.maxForwardShield))
				{  // if we just strengthened the aft shield, but the forward shield also needs some juice and we have the energy for it
				player.ship.forwardShield += this.strength;
				player.ship.energy -= this.strength;						
				return;
				}	
			}
		}   	        
	}
		
this.shipWillDockWithStation = this.shipDied = function()
	{
	if(this.shieldCheckTimer) { this.shieldCheckTimer.stop(); }
	}